<?php
// www.p30vel.ir is the Best Publisher 
if(!defined("access")){die();}
Class Activate{
	
	//user email
	private $email;
	//user code
	private $code;
	//user hash
	private $hash;
	
	//is the account already activated?
	//is needed if the user already tries to activate an already activated account
	private $isActivated = false;
	
	//errors we will be showing to the user
	private $error = '';
	//which field have errors so they get a red border
	private $error_fields = '';
	
	//initializes the email and code variables
	function __construct($email, $code){
		$misc = new Misc();
		//escape email and code
		$this->email = $misc->escapeValue($misc->trimValue($email));
		$this->code = $misc->escapeValue($misc->trimValue($code));
	}
	
	/* Insert the activation record
	 * and email the user
	*/
	public function insertActivation(){
		$email = new Email();
		$misc = new Misc();
		//get random number and md5 it, we will use it as the hash
		$hash = md5(rand(0000000, 9999999));
		//insert record
		mysql_query("INSERT INTO activation_links VALUES ('', '$this->email', '$hash', '0')");
		//subject of email
		$subject = 'Account Activation';
		//body of email
		$reciever_message = "User $this->email\n\n thank you for signing up!However you have to activate your account in order to sign in.\n\n\n\n";
		$reciever_message .= "Please go back to our website and enter your email: $this->email\n\n\n and your code: $hash to activate your account";
		//send email
		$email->sendEmail($this->email, $misc->sender_email, $subject, $reciever_message);
	}
	
	/* Checks for validation and returns errors or activates the user account
	*/
	public function activateUser(){
		$misc = new Misc();
		//if the account is already activated then exit the script
		if ($this->accountActivated($this->email)){
			$this->error .= '<li>This account is already activated.</li>';
			$this->error_fields .= 'email';
			$this->isActivated = true;
		}
		//if its not activated proceed
		if ($this->isActivated == false){
			//if not entered empty data - continue
			if ($this->email != "" && $this->code != ""){
				//is the email address valid? if not throw an error
				if(preg_match( "/^[\d\w\/+!=#|$?%{^&}*`'~-][\d\w\/\.+!=#|$?%{^&}*`'~-]*@[A-Z0-9][A-Z0-9.-]{1,61}[A-Z0-9]\.[A-Z]{2,6}$/ix", $this->email ) == 0){
					$this->error .= '<li>Please enter a valid Email address.</li>';
					$this->error_fields .= 'email,';
				}
				//if the email exist
				if ($misc->emailExist($this->email)){
					//if the user exists in the waiting users to get activated
					if ($this->checkEmail()){
						//get the activation code
						$code = $this->getAccountActivationCode();
						//if given versus the one from database are equal - proceed else throw error
						if ($this->code == $code){
							//activate the account
							$this->queryActivation();
						}else{
							$this->error .= '<li>Please insert the correct code.</li>';
							$this->error_fields .= 'email,code';
						}
					}else{
						$this->error .= '<li>We cant activate this email address.</li>';
						$this->error_fields .= 'email';
					}
				}else{
					$this->error .= '<li>This email address does not exist.</li>';
					$this->error_fields .= 'email';
				}
				
			}else{
				//all fields are blank, tell the user to fill them.
				$this->error .= '<li>Please fill both fields.</li>';
				//red marked fields
				$this->error_fields .= 'email,code';
			}
		}
		
		if ($this->error == ""){
			//send user a message that the account is activated
			$array = array(
				'error' => false,
				'message' => 'Congratulations... your account has been successfully activated!',
				'inputs_errors' => ''
			);
		}else{
			//else send the errors
			$array = array(
				'error' => true,
				'message' => '<ul style="padding:0;margin:0;margin-left:15px;">'.$this->error.'</ul>',
				'inputs_errors' => $this->error_fields
			);
		}
		return $array;
	}
	
	/* Sends new activation code the the user
	*/
	public function resentActivationCode(){
		$misc = new Misc();
		
		//if the account is already activated we cant send a new code... can we?
		if ($this->accountActivated($this->email)){
			$this->error .= '<li>This account is already activated.</li>';
			$this->error_fields .= 'email';
			$this->isActivated = true;
		}
		//so if the user is not activated
		if ($this->isActivated == false && $misc->approve_accounts == false){
			//and entered an email
			if ($this->email != ""){
				//is the email address valid? if not throw an error
				if(preg_match( "/^[\d\w\/+!=#|$?%{^&}*`'~-][\d\w\/\.+!=#|$?%{^&}*`'~-]*@[A-Z0-9][A-Z0-9.-]{1,61}[A-Z0-9]\.[A-Z]{2,6}$/ix", $this->email ) == 0){
					$this->error .= '<li>Please enter a valid Email address.</li>';
					$this->error_fields .= 'email,';
				}
				//if email exists
				if ($misc->emailExist($this->email)){
					//and since the user needs new activation code then its already in the waiting list for users to get activated..
					if ($this->checkEmail()){
						//delete all users records from the activation list
						$this->deleteUserRecords();
						//and send new activation code to the users email
						$this->insertActivation();
					}else{
						$this->error .= '<li>We cant activate this email address.</li>';
						$this->error_fields .= 'email';
					}
				}else{
					$this->error .= '<li>This email address does not exist.</li>';
					$this->error_fields .= 'email';
				}
				
			}else{
				//all fields are blank, tell the user to fill them.
				$this->error .= '<li>Please fill in the field.</li>';
				//red marked fields
				$this->error_fields .= 'email';
			}
		}else{
			$this->error .= '<li>You cant sent a new activation code because admin must approve the accounts first.</li>';
			$this->error_fields .= 'email';
		}
		
		if ($this->error == ""){
			//send user a message that the account is activated
			$array = array(
				'error' => false,
				'message' => 'Activation code has been sent to your email.',
				'inputs_errors' => ''
			);
		}else{
			//else send the errors
			$array = array(
				'error' => true,
				'message' => '<ul style="padding:0;margin:0;margin-left:15px;">'.$this->error.'</ul>',
				'inputs_errors' => $this->error_fields
			);
		}
		return $array;
	}
	
	/* updates activation list table and sets that the user is activated
	 * also updates the user table and sets the activated column with 1
	*/
	private function queryActivation(){
		mysql_query("UPDATE activation_links SET done='1' WHERE done='0' && email='$this->email' && hash='$this->code'");
		mysql_query("UPDATE users SET user_activated='1' WHERE user_activated='0' && user_email='$this->email'");
	}
	
	/* activates the user account
	*/
	private function accountActivated(){
		$q = mysql_query("SELECT user_activated FROM users WHERE user_email='$this->email'");
		$rows = mysql_fetch_array($q);
		$status = $rows[0];
		if ($status == 1){
			return true;
		}else return false;
	}
	
	/* Deletes the user records from the activation list
	*/
	private function deleteUserRecords(){
		mysql_query("DELETE FROM activation_links WHERE email='$this->email'");
	}
	
	/* gets the code that is needed to activate the account
	*/
	private function getAccountActivationCode(){
		$q = mysql_query("SELECT hash FROM activation_links WHERE email='$this->email'");
		$rows = mysql_fetch_array($q);
		return $rows[0];
	}
	
	/* checks if the user exists in the activation list
	*/
	private function checkEmail(){
		$q = mysql_query("SELECT * FROM activation_links WHERE email='$this->email'");
		$rows = mysql_num_rows($q);
		if ($rows){
			return true;
		}else return false;
	}
	
}
?>