<?php
// www.p30vel.ir is the Best Publisher 
if(!defined("access")){die();}
Class Administration{
	
	private $settings = array();
	
	//set starting values
	function __consruct(){
		$this->settings["username"] = md5('admin');//admin username
		$this->settings["password"] = md5('admin');//admin password
	}
	
	//get admin login form
	private function getAdminLoginForm(){
		?>
		<div class="admin_login_form">
			<h2 >Admin Login</h2>
			<form action="" method="post">
			<label>Username:</label><input type="text" name="username" /><br />
			<label>Password:</label><input type="password" name="password" /><br /><br /><br />
			<input type="submit" value="Log in" name="admin_login" />
			</form>
			<?php
				$username = isset($_POST["username"]) ? $_POST["username"] : "";
				$password = isset($_POST["password"]) ? $_POST["password"] : "";
				$button = isset($_POST["admin_login"]) ? $_POST["admin_login"] : "";
				$this->__consruct();//set constructor
				$this->loginAdmin($username, $password, $button);//login user
			?>
		</div>
		<?php
	}
	
	/* @param username VARCHAR - admin username
	 * @param password VARCHAR - admin password
	 * @param button - login button
	 * logs in the admin or returns error message
	*/
	private function loginAdmin($username, $password, $button){
		if ($button){
			if (md5($username) == $this->settings["username"] && md5($password) == $this->settings["password"]){
				//log in the admin
				//set admin session
				$_SESSION["logged_as_admin"] = 1;
				//log out the user if was previously logged in as a normal user
				unset($_SESSION["username"]);
				unset($_SESSION["email"]);
				unset($_SESSION["user_id"]);
				//redirect
				header("Location: ../admin_page.php");
			}else
				echo '<span class="red">Your username or password are not correct.</span>';
		}
	}
	
	//check if logged in
	//returns BOOL
	private function loggedin(){
		if (isset($_SESSION["logged_as_admin"])){
			return true;
		}else return false;
	}
	
	/* @param action VARCHAR - user action
	 * @param acc_id INT - user account ID
	 * gets admin login form or page
	*/
	public function startAdministration($action, $acc_id){
		if ($this->loggedin()){//if logged in get admin panel
			$this->getAdminPage($action, $acc_id);
		}else{//otherwise get login form
			$this->getAdminLoginForm();
		}
	}
	
	/* @param action VARCHAR - get user admin
	 * @param acc_id INT - user acc ID
	 * returns user page
	*/
	private function getAdminPage($action, $acc_id){
		?>
			<div class="admin_header">
				<h2>Welcome Admin, This is your administration panel.</h2>
			</div>
			<div class="admin_navigation">
				<ul>
					<li>
					<a href="?action=view_accounts"<?php if ($action == "view_accounts"){ echo ' class="active"'; } ?>>View/Edit Accounts</a>
					</li>
					<li>
					<a href="?action=add_account"<?php if ($action == "add_account"){ echo ' class="active"'; } ?>>Add an Account</a>
					</li>
					<li>
					<a href="?action=view_na"<?php if ($action == "view_na"){ echo ' class="active"'; } ?>>View not activated accounts</a>
					</li>
					<li>
					<a href="?action=view_a"<?php if ($action == "view_a"){ echo ' class="active"'; } ?>>View activated accounts</a>
					</li>
					<li>
					<a href="?action=view_stats" <?php if ($action == "view_stats"){ echo ' class="active"'; } ?>>View Statistics</a>
					</li>
					<li>
					<a href="?action=logout" style="border-right:0;">Logout</a>
					</li>
				</ul>
			</div>
			<div class="admin_page_content">
				<?php
					echo $this->getPageContentTitle($action);//get page content title
					echo '<div class="page_content_big_container">';
					$this->getPageContent($action, $acc_id);//and its contains
					echo '</div>';
				?>
			</div>
		<?php
	}
	
	/* @param action VARCHAR - user action
	 * @param acc_id INT - user acc ID
	 * returns the user page by the action
	*/
	private function getPageContent($action, $acc_id){
		$misc = new Misc();
		$ui = new UserInterface();
		if ($action == "view_accounts"){//requesting the accounts
			$this->getUsersList("all");
		}else if ($action == "activate"){//activating user account
			if ($misc->checkStatus("deactivate", $acc_id)){
				$this->ActivateAccount($acc_id);
				header("Location: ../admin_page.php?action=view_na");
			}else
				echo "This account is already activated.";
		}else if ($action == "deactivate"){//removing activation from an user
			if ($misc->checkStatus("activated", $acc_id)){
				$this->deActivateAccount($acc_id);
				header("Location: ../admin_page.php?action=view_a");
			}else
				echo "This account is already deactivated.";
		}else if ($action == "delete"){//deleting a user
			if ($misc->userExist($acc_id)){
				$this->deleteAccount($acc_id);
				header("Location: ../admin_page.php");
			}else
				echo 'This account does not exist.';
		}else if ($action == "add_account"){//adding a new account
			$ui->getAdminNewAccountForm();
		}else if ($action == "logout"){//logging out
			session_destroy();
			header("Location: ../admin_page.php");
		}else if ($action == "view_na"){//viewing not activated accounts
			$this->getUsersList("na");
		}else if ($action == "view_a"){//viewing activated accounts
			$this->getUsersList("a");
		}else if ($action == "view_stats"){//viewing admin panel statistics
			$this->getStatistics();
		}else//page not found..?
			echo 'Page not Found.';
	}
	
	//get how many pictures has changed to the default ones
	//used for the statistics Page
	private function getTotalChangedPicturesCount(){
		$q = mysql_query("SELECT * FROM users");
		$total_changed_pics = 0;
		$nrows = mysql_num_rows($q);
		if ($nrows){
			while ($rows = mysql_fetch_assoc($q)){
				if ($rows["picture"] != "photos/default_female.png" && $rows["picture"] != "photos/default_male.png"){
					$total_changed_pics++;
				}
			}
		}
		return $total_changed_pics;
	}
	
	//get statistics page
	private function getStatistics(){
		$q = mysql_query("SELECT *,
						  COUNT(id) AS total_accounts,
						  SUM(IF(user_activated = '1', 1,0)) AS `total_activated_accounts`,
						  SUM(IF(user_activated = '0', 1,0)) AS `total_unactivated_accounts`,
						  SUM(IF(user_gender = '1', 1,0)) AS `total_male_users`,
						  SUM(IF(user_gender = '2', 1,0)) AS `total_female_users`
						  FROM users
					   ");
		$rows = mysql_fetch_array($q);
		$total_accounts = $rows["total_accounts"];//total accounts
		$total_activated_accounts = $rows["total_activated_accounts"];//total activated accs
		$total_unactivated_accounts = $rows["total_unactivated_accounts"];//total unactivated accs
		$total_male_users = $rows["total_male_users"];//total male users
		$total_female_users = $rows["total_female_users"];//total female users
		$total_changed_pics = $this->getTotalChangedPicturesCount();//total changed pics
		$a_percent = round(($total_activated_accounts/$total_accounts) * 100);//percentage
		$una_percent = round(($total_unactivated_accounts/$total_accounts) * 100);//percentage
		$m_percent = round(($total_male_users/$total_accounts) * 100);//percentage
		$fem_percent = round(($total_female_users/$total_accounts) * 100);//percentage
		$picc_percent = round(($total_changed_pics/$total_accounts) * 100);//percentage
		?>
		<div class="stats_contentainer1">
			<div class="s_c_title">Total Accounts &raquo;</div>
			<span class="s_c_total"><?php echo $total_accounts; ?></span>
		</div>
		<div class="stats_contentainer1">
			<div class="s_c_title">Total Activated Accounts (<?php echo $a_percent.'%'; ?>) &raquo;</div>
			<span class="s_c_total"><?php echo $total_activated_accounts; ?></span>
		</div>
		<div class="stats_contentainer1">
			<div class="s_c_title">Total not Activated Accounts (<?php echo $una_percent.'%'; ?>) &raquo;</div>
			<span class="s_c_total"><?php echo $total_unactivated_accounts; ?></span>
		</div><br /><br /><br /><br />
		<div class="stats_contentainer1">
			<div class="s_c_title">Total Male Accounts (<?php echo $m_percent.'%'; ?>) &raquo;</div>
			<span class="s_c_total"><?php echo $total_male_users; ?></span>
		</div>
		<div class="stats_contentainer1">
			<div class="s_c_title">Total Female Accounts (<?php echo $fem_percent.'%'; ?>) &raquo;</div>
			<span class="s_c_total"><?php echo $total_female_users; ?></span>
		</div>
		<div class="stats_contentainer1">
			<div class="s_c_title">Users Changed Default Picture (<?php echo $total_changed_pics.'%'; ?>) &raquo;</div>
			<span class="s_c_total"><?php echo $total_changed_pics; ?></span>
		</div>
		<?php
	}
	
	//delete user account by @param acc_id INT
	private function deleteAccount($acc_id){
		$misc = new Misc();
		$photos = new Photos();
		$email = $misc->getUserEmail($acc_id);
		$current_image = $photos->getCurrentImage($acc_id);
		if ($current_image != "photos/default_male.png" && $current_image != "photos/default_female.png"){
			unlink($current_image);//remove image if not default
		}
		mysql_query("DELETE FROM users WHERE user_id='$acc_id'");
		mysql_query("DELETE FROM activation_links WHERE email='$email'");
		mysql_query("DELETE FROM recover WHERE recover_email ='$email'");
	}
	
	/* @param method VARCHAR - the page we are checking
	 * returns the page through the method VAR
	*/
	private function getUsersList($method){
		$misc = new Misc();
		$ui = new UserInterface();
		if ($method == "all"){//viewing all users
			$q = mysql_query("SELECT * FROM users ORDER BY id DESC");
		}else if ($method == "na"){//viewing not activated users
			$q = mysql_query("SELECT * FROM users WHERE user_activated='0' ORDER BY id DESC");
		}else if ($method == "a"){//viewing activated users
			$q = mysql_query("SELECT * FROM users WHERE user_activated='1' ORDER BY id DESC");
		}
		$nrows = mysql_num_rows($q);
		if ($nrows){
			while ($rows = mysql_fetch_assoc($q)){
				$username = $rows["user_name"];
				$data = $misc->getUserData($username);
				$user_id = $rows["user_id"];
				$picture = $rows["picture"];
				$isActivted = $rows["user_activated"];
				if ($isActivted == 1){
					$status = "Deactivate";
				}else{
					$status = "Activate";
				}
				?>
				<div class="view_account_container">
					<img src="<?php echo $picture; ?>" class="user_avatar" />
					<div class="view_account_body">
						Username: <strong><?php echo $username; ?></strong><br />
						<span class="account_body_actions"><a href="#" class="link2 account_edit">Edit</a> &bull; <a href="?action=<?php echo strtolower($status); ?>&acc_id=<?php echo $user_id; ?>" class="link2"><?php echo $status; ?></a> &bull; <a href="?action=delete&acc_id=<?php echo $user_id; ?>" class="link2">Delete</a></span>
					</div>
					<div class="view_account_edit_container">
						<?php echo $ui->getAdminAccountEditForm($username); ?>
					</div>
				</div>
				<?php
			}
		}else
			echo '<span class="message_error" style="display:block;width:98%;margin-left:3px;">There are no accounts to show.</span>';
		
	}
	
	//get page title
	private function getPageContentTitle($action){
		$misc = new Misc();
		if ($action == "view_accounts"){
			$total_users = $misc->getTotalUsers();
			return '<h2>View / Edit accounts<span style="float:right;font-size:16px;margin-top:5px;">'.$total_users.' accounts found</span></h2>';
		}else if ($action == "add_account"){
			return '<h2>Add an Account</h2>';
		}else if ($action == "view_na"){
			$total_nactivated = $misc->getTotalUnactivatedAccounts();
			return '<h2>Viewing Not Activated Accounts<span style="float:right;font-size:16px;margin-top:5px;">'.$total_nactivated.' accounts found</span></h2>';
		}else if ($action == "view_a"){
			$total_activated = $misc->getTotalActivatedAccounts();
			return '<h2>Viewing Activated Accounts<span style="float:right;font-size:16px;margin-top:5px;">'.$total_activated.' accounts found</span></h2>';
		}else if ($action == "view_stats"){
			return '<h2>Viewing Statistics</h2>';
		}else{
			return '<h2>Page not Found</h2>';
		}
	}
	
	//deactivate account via @param acc_id INT
	private function deActivateAccount($acc_id){
		mysql_query("UPDATE users SET user_activated='0' WHERE user_id='$acc_id' && user_activated='1'");
	}
	
	//activate account via @param acc_id INT
	private function ActivateAccount($acc_id){
		mysql_query("UPDATE users SET user_activated='1' WHERE user_id='$acc_id' && user_activated='0'");
	}
	
}
?>