<?php
// www.p30vel.ir is the Best Publisher 
if(!defined("access")){die();}
Class ChangeSettings{
	
	private $username;
	private $firstname;
	private $lastname;
	private $current_password;
	private $password1;
	private $password2;
	private $email;
	private $gender;
	
	private $myusername;
	private $myemail;
	
	//errors we will be showing to the user
	private $error = '';
	//which field have errors so they get a red border
	private $error_fields = '';
	
	//assign starting variables
	function __construct($data){
		$misc = new Misc();
		if (isset($_SESSION["username"])){//if logged in as normal user
			//set my sessions as my email and username
			$this->myusername = $_SESSION["username"];
			$this->myemail = $_SESSION["email"];
		}else{//else use admins one
			$this->myusername = $data["username_ue"];
			$this->myemail = $data["email_ue"];
		}
		foreach ($data as $id => $val){
			//assign each item to its variable
			$this->$id = $misc->trimValue($val);//remove all spaces
		}
	}
	
	//Update user settings
	//Check for validation and proceed to update
	public function updateSettings(){
		$misc = new Misc();
		$current_db_password = $misc->getUserPassword($this->username);
		
 		if ($this->username != "" && $this->firstname != "" && $this->lastname != ""
			&& $this->email != "" && $this->gender !="")
		{
			if ($this->password1 != "" || $this->password2 != ""){
				if (md5($this->current_password) == $current_db_password){
					$this->updatePassword();
				}else{
					$this->error .= '<li>Please enter your current password corrently before you change it.</li>';
					$this->error_fields .= 'current_password,';
				}
			}
			$this->updateUsername();
			$this->updateFirstname();
			$this->updateLastname();
			$this->updateEmail();
			$this->updateGender();
		}else{
			//all fields are blank, tell the user to fill them.
			$this->error .= '<li>Please fill in all fields.</li>';
			//red marked fields
			$this->error_fields .= 'username,firstname,password,retype_password,lastname,email,gender';
		}
		
		//no errors for sure(hopefully)
		if ($this->error == ""){
			//send user a message that the account is registered
			$array = array(
				'error' => false,
				'message' => 'Settings updated',
				'inputs_errors' => ''
			);
		}else{
			//else send the errors
			$array = array(
				'error' => true,
				'message' => '<ul style="padding:0;margin:0;margin-left:15px;">'.$this->error.'</ul>',
				'inputs_errors' => $this->error_fields
			);
		}
		return $array;
	}
	
	//Update user settings when in admin panel
	//validate and proceed
	public function AdminUpdateSettings(){
		$misc = new Misc();
		
 		if ($this->username != "" && $this->firstname != "" && $this->lastname != ""
			&& $this->email != "" && $this->gender !="")
		{
			if ($this->password1 != "" || $this->password2 != ""){
				$this->updatePassword();
			}
			$this->updateUsername();
			$this->updateFirstname();
			$this->updateLastname();
			$this->updateEmail();
			$this->updateGender();
		}else{
			//all fields are blank, tell the user to fill them.
			$this->error .= '<li>Please fill in all fields.</li>';
			//red marked fields
			$this->error_fields .= 'username,firstname,password,retype_password,lastname,email,gender';
		}
		
		//no errors for sure(hopefully)
		if ($this->error == ""){
			//send user a message that the account is registered
			$array = array(
				'error' => false,
				'message' => 'Settings updated',
				'inputs_errors' => ''
			);
		}else{
			//else send the errors
			$array = array(
				'error' => true,
				'message' => '<ul style="padding:0;margin:0;margin-left:15px;">'.$this->error.'</ul>',
				'inputs_errors' => $this->error_fields
			);
		}
		return $array;
	}
	
	//update password by validating
	private function updatePassword(){
		//if password1 does not meet our criteria for the password (at least 6 characters length with maximum
		//of 128 characters and alphanumeric throw an error
		if (!ctype_alnum($this->password1)
			|| strlen($this->password1)<6
			|| strlen($this->password1)>=128
			|| !preg_match('`[A-Z]`',$this->password1)
			|| !preg_match('`[a-z]`',$this->password1)
			|| !preg_match('`[0-9]`',$this->password1)
		){
			$this->error .= '<li>Your first password must have at least one of each: a-z A-Z 0-9 and be atleast 6 characters.</li>';
			$this->error_fields .= 'password,';
		}
		
		//if password2 does not meet our criteria for the password (at least 6 characters length with maximum
		//of 128 characters and alphanumeric throw an error
		if (!ctype_alnum($this->password2)
			|| strlen($this->password2)<6
			|| strlen($this->password2)>=128
			|| !preg_match('`[A-Z]`',$this->password2)
			|| !preg_match('`[a-z]`',$this->password2)
			|| !preg_match('`[0-9]`',$this->password2)
		){
			$this->error .= '<li>Your second password must have at least one of each: a-z A-Z 0-9 and be atleast 6 characters.</li>';
			$this->error_fields .= 'retype_password,';
		}
		
		if ($this->error == ""){
			if ($this->password1 == $this->password2){
				$password = md5($this->password1);
				mysql_query("UPDATE users SET user_password='$password' WHERE user_name='$this->myusername'");
			}else{
				$this->error .= '<li>Your passwords do not match.</li>';
				$this->error_fields .= 'password,retype_password';
			}
		}
	}
	
	//update firstname of the user
	private function updateFirstname(){
		//1 to 100 characters count for firstname
		if (strlen($this->firstname) < 1 || strlen($this->firstname) > 100){
			$this->error .= '<li>Your Firstname must be between 1 and 100 characters.</li>';
			$this->error_fields .= 'firstname,';
		}
		if ($this->error == ""){
			mysql_query("UPDATE users SET user_firstname='$this->firstname' WHERE user_name='$this->myusername'");
		}
	}
	
	//update firstname of the user
	private function updateLastname(){
		//1 to 100 characters count for firstname
		if (strlen($this->lastname) < 1 || strlen($this->lastname) > 100){
			$this->error .= '<li>Your Lastname must be between 1 and 100 characters.</li>';
			$this->error_fields .= 'lastname,';
		}
		if ($this->error == ""){
			mysql_query("UPDATE users SET user_lastname='$this->lastname' WHERE user_name='$this->myusername'");
		}
	}
	
	//update email of the user
	private function updateEmail(){
		$misc = new Misc();
		//is the email address valid? if not throw an error
		if(preg_match( "/^[\d\w\/+!=#|$?%{^&}*`'~-][\d\w\/\.+!=#|$?%{^&}*`'~-]*@[A-Z0-9][A-Z0-9.-]{1,61}[A-Z0-9]\.[A-Z]{2,6}$/ix", $this->email ) == 0){
			$this->error .= '<li>Please enter a valid Email address.</li>';
			$this->error_fields .= 'email,';
		}
		if ($this->error == "" && $this->email != $this->myemail){
			if (!$misc->emailExist($this->email)){
				mysql_query("UPDATE users SET user_email='$this->email' WHERE user_name='$this->myusername'");
				if (isset($_SESSION["username"])){
					$_SESSION["email"] = $this->email;
					$this->myemail = $_SESSION["email"];
				}
			}else{
				$this->error .= '<li>This email already exists.</li>';
				$this->error_fields .= 'email,';
			}
		}
	}
	
	//update gender of the user
	private function updateGender(){
		//if gender is not a Male or Female, tell the user to Select one.
		if ($this->gender != 1 && $this->gender != 2){
			$this->error .= '<li>Please Select your Gender.</li>';
			$this->error_fields .= 'gender,';
		}
		
		if ($this->error == ""){
			if ($this->gender == 1 || $this->gender == 2){
				mysql_query("UPDATE users SET user_gender='$this->gender' WHERE user_name='$this->myusername'");
				$this->updatePicture();
			}else{
				$this->error .= '<li>Please Select your Gender.</li>';
				$this->error_fields .= 'gender,';
			}
		}
	}
	
	//update picture of the user
	private function updatePicture(){
		$photos = new Photos();
		if ($photos->hasDefaultPicture($this->myusername) == "Male"){
			if ($this->gender == 2){
				mysql_query("UPDATE users SET picture='photos/default_female.png' WHERE user_name='$this->myusername'");
			}
		}else if ($photos->hasDefaultPicture($this->myusername) == "Female"){
			if ($this->gender == 1){
				mysql_query("UPDATE users SET picture='photos/default_male.png' WHERE user_name='$this->myusername'");
			}
		}
	}
	
	//update username of the user
	private function updateUsername(){
		$misc = new Misc();
		//check if username chars length < 1 or > 20 and does not meet our pattern, throw an error
		if (strlen($this->username) < 1 || strlen($this->username) > 20){
			$this->error .= '<li>Your Username must be between 1 and 20 characters</li>';
			$this->error_fields .= 'username,';
		}
		
		//pattern for username
		$pattern = "/[^0-9A-Za-z]/";
		$validator = preg_match($pattern, $this->username);
		if ($validator == 1){
			$this->error .= '<li>Your Username characters must be a-z A-Z 0-9</li>';
			$this->error_fields .= 'username,';
		}
		
		if ($this->error == "" && $this->username != $this->myusername){
			if (!$misc->usernameExist($this->username)){
				mysql_query("UPDATE users SET user_name='$this->username' WHERE user_name='$this->myusername'");
				if (isset($_SESSION["username"])){
					$_SESSION["username"] = $this->username;
					$this->myusername = $_SESSION["username"];
				}
			}else{
				$this->error .= '<li>This username already exists.</li>';
				$this->error_fields .= 'username,';
			}
		}
		
	}
	
}
?>